//+------------------------------------------------------------------+
//|                                         Super_Wave_Main |
//+------------------------------------------------------------------+
string Name_Indicator = "Super_Wave_Main",
       Ver = "GS_2010_07_23",
       Autor = "  valenok2003@mail.ru";
string Name_Window;
int Shift_X = 5;
int Shift_Y = 20;
int Win_TF; 
string Txt_Win_TF;
//extern 
int Custom_TF = 0;
string Txt_Custom_TF;
extern bool Alert_ON = false;
extern bool Comment_ON = false;
//+---   --------------------------------------------+
datetime Day_Check = 1200;
int Sec_in_Day = 86400;
datetime Start_Date = 1279809762; //22  2010 
string Txt_Protect = ":     .";
//+------------------------------------------------------------------+
int Shou_Line = DRAW_LINE; // DRAW_NONE; // 

#property copyright "Sergey Gulyaev. Maykop."

#property indicator_separate_window

//#property indicator_minimum -100
//#property indicator_maximum 100

#property indicator_buffers 8
#property indicator_color1 Gray
#property indicator_color2 White
#property indicator_color3 Yellow
#property indicator_color4 Lime
#property indicator_color5 Red
#property indicator_color6 Tomato
#property indicator_color7 DodgerBlue
#property indicator_color8 Blue

int Stoch_D=5;
int Stoch_K=3;
int Stoch_S=3;

extern string Rem_00 = "-  -";
extern string Rem_01 = "-,   -";
extern string Rem_02 = "-  -";
extern int Period_Average_White  = 3;
extern int Period_Average_Yellow = 20;
extern int Period_Average_Green = 100;

extern string Rem_2 = "- -";
extern bool Show_Gray = true;
extern bool Show_White = false;
extern bool Show_Yellow = true;
extern bool Show_Green = true;

extern string Rem_30 = "-   -";
extern string Rem_31 = "-  -";
extern string Rem_32 = "-    -";
extern int Bar_for_Search_LVL_short = 60;
extern int _Level_Signal_Line_short = 60;
extern int Bar_for_Search_LVL_long = 240;
extern int _Level_Signal_Line_long = 80;

extern string Rem_4 = "-  -";
extern int Period_Refresh = 120;

//----------------
//#include <my_librarias_2010_08_06.mqh>
//----------------
double St_One , St_Two, St_Three, St_Four, St_Five, St_Six,
       Tmp_Sum;
               
double Max_SA,
       Min_SA,
       Level_Signal_Line_short,
       Level_Signal_Line_long,
       One_percent; 

bool FLAG_EVENT = false;

int Start_Time,
    Cur_time,
    Fault;

int z = 1;

string Var_Comment = "",
       Trend_Sum_Average_White = "",
       Trend_Sum_Average_Yellow = "",
       Trend_Sum_Average_Green = "",
       Last_Event = "      ";

//---- buffers
double Stoch_Sum[],    //0
       Sum_Average_White[], //1
       Sum_Average_Yellow[], //2
       Sum_Average_Green[], //3
       Level_Top_Long[],     //4
       Level_Top_Short[],    //5  
       Level_Boot_Short[],   //6
       Level_Boot_Long[];    //7
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{
   Win_TF = Period();
//--------------------------------------------------------------------
   switch(Win_TF)
   {
     case PERIOD_M1:  Txt_Win_TF = "M1";  break;
     case PERIOD_M5:  Txt_Win_TF = "M5";  break;
     case PERIOD_M15: Txt_Win_TF = "M15"; break;
     case PERIOD_M30: Txt_Win_TF = "M30"; break;
     case PERIOD_H1:  Txt_Win_TF = "H1";  break;
     case PERIOD_H4:  Txt_Win_TF = "H4";  break;
     case PERIOD_D1:  Txt_Win_TF = "D1";  break;
     case PERIOD_W1:  Txt_Win_TF = "W1";  break;
     case PERIOD_MN1: Txt_Win_TF = "MN1"; break;
     default: break;
   }
//--------------------------------------------------------------------
   if(Custom_TF == 0)
   {
     Custom_TF = Win_TF;
   }
   if(Custom_TF < Win_TF)
   {
     Alert(Name_Indicator + ": " + ",    ,     .",
           "\n                            ,  0."); 
     Custom_TF = Win_TF;
   }
   if(Custom_TF > Win_TF)
   {
     switch(Win_TF)
     {
       case PERIOD_M1:
         switch(Custom_TF)
         {
           case PERIOD_M1:  z = 1;   break;
           case PERIOD_M5:  z = 5;   break;
           case PERIOD_M15: z = 15;  break;
           case PERIOD_M30: z = 30;  break;
           case PERIOD_H1:  z = 60;  break;
           case PERIOD_H4:  z = 240; break;
           default: Alert(Name_Indicator + ": "+"  !\n   : 1,5,15,30,60,240!"); 
           Custom_TF = Win_TF; break;
         }
       break;
       case PERIOD_M5:
         switch(Custom_TF)
         {
           case PERIOD_M5:  z = 1;   break;
           case PERIOD_M15: z = 3;   break;
           case PERIOD_M30: z = 6;   break;
           case PERIOD_H1:  z = 12;  break;
           case PERIOD_H4:  z = 48;  break;
           case PERIOD_D1:  z = 288; break;
           default: Alert(Name_Indicator + ": "+"  !\n   : 5,15,30,60,240,1440!"); 
           Custom_TF = Win_TF; break;
         }
       break;
       case PERIOD_M15:
         switch(Custom_TF)
         {
           case PERIOD_M15: z = 1;    break;
           case PERIOD_M30: z = 2;    break;
           case PERIOD_H1:  z = 4;    break;
           case PERIOD_H4:  z = 16;   break;
           case PERIOD_D1:  z = 96;   break;
           case PERIOD_W1:  z = 672;  break;
           default: Alert(Name_Indicator + ": "+"  !\n   : 15,30,60,240,1440,10080!"); 
           Custom_TF = Win_TF; break;
         }
       break;
       case PERIOD_M30:
         switch(Custom_TF)
         {
           case PERIOD_M30: z = 1;    break;
           case PERIOD_H1:  z = 2;    break;
           case PERIOD_H4:  z = 8;    break;
           case PERIOD_D1:  z = 48;   break;
           case PERIOD_W1:  z = 336;  break;
           case PERIOD_MN1: z = 1440; break;
           default: Alert(Name_Indicator + ": "+"  !\n   : 30,60,240,1440,10080,43200!"); 
           Custom_TF = Win_TF; break;
         }
       break;
       case PERIOD_H1:  
         switch(Custom_TF)
         {
           case PERIOD_H1:  z = 1;   break;
           case PERIOD_H4:  z = 4;   break;
           case PERIOD_D1:  z = 24;  break;
           case PERIOD_W1:  z = 168; break;
           case PERIOD_MN1: z = 720; break;
           default: Alert(Name_Indicator + ": "+"  !\n   : 60,240,1440,10080,43200!"); 
           Custom_TF = Win_TF; break;
         }
       break;
       case PERIOD_H4:  
         switch(Custom_TF)
         {
           case PERIOD_H4:  z = 1;   break;
           case PERIOD_D1:  z = 6;   break;
           case PERIOD_W1:  z = 42;  break;
           case PERIOD_MN1: z = 180; break;
           default: Alert(Name_Indicator + ": "+"  !\n   : 240,1440,10080,43200!"); 
           Custom_TF = Win_TF; break;
         }
       break;
       case PERIOD_D1:  
         switch(Custom_TF)
         {
           case PERIOD_D1:  z = 1;  break;
           case PERIOD_W1:  z = 7;  break;
           case PERIOD_MN1: z = 30; break;
           default: Alert(Name_Indicator + ": "+"  !\n   : 1440,10080,43200!"); 
           Custom_TF = Win_TF; break;
         }
       break;
       case PERIOD_W1:  
         switch(Custom_TF)
         {
           case PERIOD_W1:  z = 1; break;
           case PERIOD_MN1: z = 4; break;
           default: Alert(Name_Indicator + ": "+"  !\n   : 10080,43200!"); 
           Custom_TF = Win_TF; break;
         }
       break;
       case PERIOD_MN1:  
         switch(Custom_TF)
         {
           case PERIOD_MN1: z = 1; break;
           default: Alert(Name_Indicator + ": "+"  !\n   : 43200!"); 
           Custom_TF = Win_TF; break;
         }
       break;
       default: Alert(Name_Indicator + ": "+"  !\n: 1,5,15,30,60,1440,10080,43200!"); 
       Custom_TF = Win_TF; break;
     }
   }
//--------------------------------------------------------------------
  Cur_time = TimeCurrent();
  Fault= MathMod(Cur_time, Period_Refresh);
  Start_Time = Cur_time - Fault;
  Txt_Custom_TF = Txt_TF(DoubleToStr(Custom_TF,0), Custom_TF);
//------------    -------------------------------------- 
//---- name for indicator window
   Name_Window = Name_Indicator + " " + Ver + " " + Autor;
   IndicatorShortName(Name_Window);
//--------------------------------------------------------------------  
//---- indicators -    
  if(Show_Gray) SetIndexStyle(0,Shou_Line); else SetIndexStyle(0,DRAW_NONE);
  SetIndexBuffer(0,Stoch_Sum);
  SetIndexLabel (0,"Gray(0)");

  if(Show_White) SetIndexStyle(1,Shou_Line); else SetIndexStyle(1,DRAW_NONE);
  SetIndexBuffer(1,Sum_Average_White);
  SetIndexLabel (1,"White("+Period_Average_White +")");
  
  if(Show_Yellow) SetIndexStyle(2,Shou_Line); else SetIndexStyle(2,DRAW_NONE);
  SetIndexBuffer(2,Sum_Average_Yellow);
  SetIndexLabel (2,"Yellow("+Period_Average_White +"+"+Period_Average_Yellow+")");

  if(Show_Green) SetIndexStyle(3,Shou_Line); else SetIndexStyle(3,DRAW_NONE);
  SetIndexBuffer(3,Sum_Average_Green);
  SetIndexLabel (3,"Green("+Period_Average_White +"+"+Period_Average_Yellow+"+"+Period_Average_Green+")");

  SetIndexStyle(4,Shou_Line);
  SetIndexBuffer(4,Level_Top_Long);
  SetIndexLabel (4,_Level_Signal_Line_long + "%  Max  " + _Level_Signal_Line_long + " ");

  SetIndexStyle(5,Shou_Line);
  SetIndexBuffer(5,Level_Top_Short);
  SetIndexLabel (5,_Level_Signal_Line_short + "%  Max  " + _Level_Signal_Line_short + " ");

  SetIndexStyle(6,Shou_Line);
  SetIndexBuffer(6,Level_Boot_Short);
  SetIndexLabel (6,_Level_Signal_Line_short + "%  Min  " + _Level_Signal_Line_short + " ");

  SetIndexStyle(7,Shou_Line);
  SetIndexBuffer(7,Level_Boot_Long);
  SetIndexLabel (7,_Level_Signal_Line_long + "%  Min  " + _Level_Signal_Line_long + " ");
//----
   return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
{
//----
    Comment("");   
//----
   return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
{
//-----    -----------------------------------------------
   if(TimeCurrent() > Start_Date - Sec_in_Day + (Day_Check * Sec_in_Day))
   {
     Alert(Name_Indicator + Txt_Protect);
     return(0);
   }
//--------------------------------------------------------------------
   int i,                           //  
       Counted_bars,                //    
       cnt;
//--------------------------------------------------------------------
   Counted_bars=IndicatorCounted(); //    
   i = Bars-Counted_bars-1;           //   
   while(i>=0)                      //    
   {
//------------------    --------------------
     St_One   = iCustom(Symbol(), 0, "Super_Wave_Base GS_2010_07_22", Custom_TF, false, 0, i);
     St_Two   = iCustom(Symbol(), 0, "Super_Wave_Base GS_2010_07_22", Custom_TF, false, 1, i);
     St_Three = iCustom(Symbol(), 0, "Super_Wave_Base GS_2010_07_22", Custom_TF, false, 2, i); 
     St_Four  = iCustom(Symbol(), 0, "Super_Wave_Base GS_2010_07_22", Custom_TF, false, 3, i); 
     St_Five  = iCustom(Symbol(), 0, "Super_Wave_Base GS_2010_07_22", Custom_TF, false, 4, i);
     St_Six   = iCustom(Symbol(), 0, "Super_Wave_Base GS_2010_07_22", Custom_TF, false, 5, i); 
     
//-----    -----------------------------------------------
   if(TimeCurrent() > Start_Date - Sec_in_Day + (Day_Check * Sec_in_Day))
   {
     Alert(Name_Indicator + Txt_Protect);
     return(0);
   }
//--------------------------------------------------------------------
     if(Custom_TF == PERIOD_M1 || Custom_TF == PERIOD_M5 || Custom_TF == PERIOD_M15 ||Custom_TF == PERIOD_M30)
       Stoch_Sum[i] = (St_One + St_Two + St_Three + St_Four + St_Five + St_Six)/6;
     if(Custom_TF == PERIOD_H1)
       Stoch_Sum[i] = (St_One + St_Two + St_Three + St_Four + St_Five)/5;
     if(Custom_TF == PERIOD_H4)
       Stoch_Sum[i] = (St_One + St_Two + St_Three + St_Four)/4;
     if(Custom_TF == PERIOD_D1)
       Stoch_Sum[i] = (St_One + St_Two + St_Three)/3;
     if(Custom_TF == PERIOD_W1)
       Stoch_Sum[i] = (St_One + St_Two)/2;
     if(Custom_TF == PERIOD_MN1)
       Stoch_Sum[i] = St_One;

//  -------------------------------------------------      
     Tmp_Sum = 0;
     for(int n=0; n < Period_Average_White ; n++) 
     {
       Tmp_Sum = Tmp_Sum + Stoch_Sum[i+n];
     }
     Tmp_Sum =  Tmp_Sum/Period_Average_White ;
     Sum_Average_White[i] = Tmp_Sum;
//  -------------------------------------------------
     Tmp_Sum = 0;
     for(n=0; n < Period_Average_Yellow; n++) 
     {
       Tmp_Sum = Tmp_Sum + Sum_Average_White[i+n];
     }
     Tmp_Sum =  Tmp_Sum/Period_Average_Yellow;
     Sum_Average_Yellow[i] = Tmp_Sum;
//  -------------------------------------------------
     Tmp_Sum = 0;
     for(n=0; n < Period_Average_Green; n++) 
     {
       Tmp_Sum = Tmp_Sum + Sum_Average_Yellow[i+n];
     }
     Tmp_Sum =  Tmp_Sum/Period_Average_Green;
     Sum_Average_Green[i] = Tmp_Sum;
//--------------------------------------------------------------------
     i--;
   }
//    ---------------------------------------------
     cnt = WindowFirstVisibleBar();
     while(cnt >= 0)
     {
//----  ------------------------------------------------------
       Max_SA = -100000;
       Min_SA =  100000; 
//     Sum_Average_White ------------------------------
       for(n=0; n < Bar_for_Search_LVL_short*z; n++)
       {
         if(Max_SA < Sum_Average_White[n+cnt]) Max_SA = Sum_Average_White[n+cnt];
         if(Min_SA > Sum_Average_White[n+cnt]) Min_SA = Sum_Average_White[n+cnt];
       }
//--------------------------------------------------------------------
       Level_Signal_Line_short = 100 - _Level_Signal_Line_short*1.0;
       One_percent = (Max_SA - Min_SA)/100;
//--------------------------------------------------------------------
       Level_Top_Short[cnt] = Max_SA - One_percent*Level_Signal_Line_short;
       Level_Boot_Short[cnt]= Min_SA + One_percent*Level_Signal_Line_short;
//--------------------------------------------------------------------
//---- --------------------------------------------------------
       Max_SA = -100000;
       Min_SA =  100000; 
//     Sum_Average_White ------------------------------
       for(n=0; n < Bar_for_Search_LVL_long*z; n++)
       {
         if(Max_SA < Sum_Average_White[n+cnt]) Max_SA = Sum_Average_White[n+cnt];
         if(Min_SA > Sum_Average_White[n+cnt]) Min_SA = Sum_Average_White[n+cnt];
       }
//--------------------------------------------------------------------
       Level_Signal_Line_long = 100 - _Level_Signal_Line_long*1.0;
       One_percent = (Max_SA - Min_SA)/100;
//--------------------------------------------------------------------
       Level_Top_Long[cnt] = Max_SA - One_percent*Level_Signal_Line_long;
       Level_Boot_Long[cnt]= Min_SA + One_percent*Level_Signal_Line_long;
       cnt--;
     }
//--------------------------------------------------------------------
//--------   -----------------------------------------
    if(Sum_Average_White[1] > Sum_Average_White[0]) Trend_Sum_Average_White = " ";
    if(Sum_Average_White[1] < Sum_Average_White[0]) Trend_Sum_Average_White = " ";
    if(Sum_Average_Yellow[1] > Sum_Average_Yellow[0]) Trend_Sum_Average_Yellow = " ";
    if(Sum_Average_Yellow[1] < Sum_Average_Yellow[0]) Trend_Sum_Average_Yellow = " ";
    if(Sum_Average_Green[1] > Sum_Average_Green[0]) Trend_Sum_Average_Green = " ";
    if(Sum_Average_Green[1] < Sum_Average_Green[0]) Trend_Sum_Average_Green = " ";
//----------    -----------------------------
    if(Sum_Average_Yellow[1] >= Level_Top_Long[1] && Sum_Average_Yellow[0] < Level_Top_Long[0]
       && Sum_Average_Yellow[1] > Sum_Average_Yellow[0] && Level_Top_Long[1] >= Level_Top_Long[0]) //  Sum_Average_Yellow  Level_Top_Long  
       {Last_Event = "   "; FLAG_EVENT = true;}
    if(Sum_Average_Yellow[1] <= Level_Boot_Long[1] && Sum_Average_Yellow[0] > Level_Boot_Long[0]
       && Sum_Average_Yellow[1] < Sum_Average_Yellow[0] && Level_Boot_Long[1] <= Level_Boot_Long[0]) //  Sum_Average_Yellow  Level_Boot_Long  
       {Last_Event = "   "; FLAG_EVENT = true;}
//------------------------------------------------------------------
//----------    ----------------------------
    if(Sum_Average_Yellow[1] >= Level_Top_Short[1] && Sum_Average_Yellow[0] < Level_Top_Short[0] 
       && Sum_Average_Yellow[1] > Sum_Average_Yellow[0] && Level_Top_Short[1] >= Level_Top_Short[0]) //  Sum_Average_Yellow  Level_Top_Short  
       {Last_Event = "   "; FLAG_EVENT = true;}
    if(Sum_Average_Yellow[1] <= Level_Boot_Short[1] && Sum_Average_Yellow[0] > Level_Boot_Short[0]
       && Sum_Average_Yellow[1] < Sum_Average_Yellow[0] && Level_Boot_Short[1] <= Level_Boot_Short[0]) //  Sum_Average_Yellow  Level_Boot_Short  
       {Last_Event = "   "; FLAG_EVENT = true;}
//--------------------------------------------------------------------
//----------  Sum_Average_Green --------------------------------
    if(Sum_Average_Yellow[1] >= Sum_Average_Green[1] && Sum_Average_Yellow[0] < Sum_Average_Green[0]
       && Sum_Average_Yellow[1] > Sum_Average_Yellow[0]) //  Sum_Average_Yellow  Sum_Average_Green  
    {
      if(Sum_Average_Green[1] > Sum_Average_Green[0])  {Last_Event = "     "; FLAG_EVENT = true;}
      if(Sum_Average_Green[1] == Sum_Average_Green[0]) {Last_Event = "   "; FLAG_EVENT = true;}
      if(Sum_Average_Green[1] < Sum_Average_Green[0])  {Last_Event = "     "; FLAG_EVENT = true;}
    }
    if(Sum_Average_Yellow[1] <= Sum_Average_Green[1] && Sum_Average_Yellow[0] > Sum_Average_Green[0]
       && Sum_Average_Yellow[1] < Sum_Average_Yellow[0]) //  Sum_Average_Yellow  Sum_Average_Green  
    {
      if(Sum_Average_Green[1] < Sum_Average_Green[0])  {Last_Event = "     "; FLAG_EVENT = true;}
      if(Sum_Average_Green[1] == Sum_Average_Green[0]) {Last_Event = "   "; FLAG_EVENT = true;}
      if(Sum_Average_Green[1] > Sum_Average_Green[0])  {Last_Event = "     "; FLAG_EVENT = true;}
    }
//--------------------------------------------------------------------
//--------------------------------------------------------------------
  Cur_time = TimeCurrent();
//----
  if((Cur_time - Start_Time) >= Period_Refresh)
  {
    if(Alert_ON == true && FLAG_EVENT == true)
    {
      Alert(Txt_Custom_TF + " " + Last_Event);
      FLAG_EVENT = false;
    }
    Fault= MathMod(Cur_time, Period_Refresh);
    Start_Time = Cur_time - Fault;
    if(FLAG_EVENT == false) Var_Comment = " "; 
  }
  else
  {
    Var_Comment = "   " + DoubleToStr(Period_Refresh - (Cur_time - Start_Time),0) + "";
  }
  
  Var_Comment = Var_Comment + "\n_" + Txt_Custom_TF + "   : " + Last_Event + "\n" + Trend_Sum_Average_White
                + "\n" + Trend_Sum_Average_Yellow+ "\n" + Trend_Sum_Average_Green;
  if(Comment_ON)Comment(Var_Comment);
  Var_Comment = ""; 
//+------------------------------------------------------------------+
//----
   return(0);
}
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
//|        
//+------------------------------------------------------------------+
string Txt_TF(string _Name_TF, int _TF)
{  
   string _Txt_TF;
   switch(_TF)
   {
     case PERIOD_M1:  _Txt_TF = "M1";  break;
     case PERIOD_M5:  _Txt_TF = "M5";  break;
     case PERIOD_M15: _Txt_TF = "M15"; break;
     case PERIOD_M30: _Txt_TF = "M30"; break;
     case PERIOD_H1:  _Txt_TF = "H1";  break;
     case PERIOD_H4:  _Txt_TF = "H4";  break;
     case PERIOD_D1:  _Txt_TF = "D1";  break;
     case PERIOD_W1:  _Txt_TF = "W1";  break;
     case PERIOD_MN1: _Txt_TF = "MN1"; break;
     default: Alert("   " + _Name_TF); return;
   }
   return(_Txt_TF);
}
//+------------------------------------------------------------------+


